/*******************************************************************************
* File Name: isrSPI.h
* Version 1.70
*
*  Description:
*   Provides the function definitions for the Interrupt Controller.
*
*
********************************************************************************
* Copyright 2008-2015, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/
#if !defined(CY_ISR_isrSPI_H)
#define CY_ISR_isrSPI_H


#include <cytypes.h>
#include <cyfitter.h>

/* Interrupt Controller API. */
void isrSPI_Start(void);
void isrSPI_StartEx(cyisraddress address);
void isrSPI_Stop(void);

CY_ISR_PROTO(isrSPI_Interrupt);

void isrSPI_SetVector(cyisraddress address);
cyisraddress isrSPI_GetVector(void);

void isrSPI_SetPriority(uint8 priority);
uint8 isrSPI_GetPriority(void);

void isrSPI_Enable(void);
uint8 isrSPI_GetState(void);
void isrSPI_Disable(void);

void isrSPI_SetPending(void);
void isrSPI_ClearPending(void);


/* Interrupt Controller Constants */

/* Address of the INTC.VECT[x] register that contains the Address of the isrSPI ISR. */
#define isrSPI_INTC_VECTOR            ((reg32 *) isrSPI__INTC_VECT)

/* Address of the isrSPI ISR priority. */
#define isrSPI_INTC_PRIOR             ((reg32 *) isrSPI__INTC_PRIOR_REG)

/* Priority of the isrSPI interrupt. */
#define isrSPI_INTC_PRIOR_NUMBER      isrSPI__INTC_PRIOR_NUM

/* Address of the INTC.SET_EN[x] byte to bit enable isrSPI interrupt. */
#define isrSPI_INTC_SET_EN            ((reg32 *) isrSPI__INTC_SET_EN_REG)

/* Address of the INTC.CLR_EN[x] register to bit clear the isrSPI interrupt. */
#define isrSPI_INTC_CLR_EN            ((reg32 *) isrSPI__INTC_CLR_EN_REG)

/* Address of the INTC.SET_PD[x] register to set the isrSPI interrupt state to pending. */
#define isrSPI_INTC_SET_PD            ((reg32 *) isrSPI__INTC_SET_PD_REG)

/* Address of the INTC.CLR_PD[x] register to clear the isrSPI interrupt. */
#define isrSPI_INTC_CLR_PD            ((reg32 *) isrSPI__INTC_CLR_PD_REG)



#endif /* CY_ISR_isrSPI_H */


/* [] END OF FILE */
