/*******************************************************************************
* File Name: isr_SPI.h
* Version 1.70
*
*  Description:
*   Provides the function definitions for the Interrupt Controller.
*
*
********************************************************************************
* Copyright 2008-2015, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/
#if !defined(CY_ISR_isr_SPI_H)
#define CY_ISR_isr_SPI_H


#include <cytypes.h>
#include <cyfitter.h>

/* Interrupt Controller API. */
void isr_SPI_Start(void);
void isr_SPI_StartEx(cyisraddress address);
void isr_SPI_Stop(void);

CY_ISR_PROTO(isr_SPI_Interrupt);

void isr_SPI_SetVector(cyisraddress address);
cyisraddress isr_SPI_GetVector(void);

void isr_SPI_SetPriority(uint8 priority);
uint8 isr_SPI_GetPriority(void);

void isr_SPI_Enable(void);
uint8 isr_SPI_GetState(void);
void isr_SPI_Disable(void);

void isr_SPI_SetPending(void);
void isr_SPI_ClearPending(void);


/* Interrupt Controller Constants */

/* Address of the INTC.VECT[x] register that contains the Address of the isr_SPI ISR. */
#define isr_SPI_INTC_VECTOR            ((reg32 *) isr_SPI__INTC_VECT)

/* Address of the isr_SPI ISR priority. */
#define isr_SPI_INTC_PRIOR             ((reg32 *) isr_SPI__INTC_PRIOR_REG)

/* Priority of the isr_SPI interrupt. */
#define isr_SPI_INTC_PRIOR_NUMBER      isr_SPI__INTC_PRIOR_NUM

/* Address of the INTC.SET_EN[x] byte to bit enable isr_SPI interrupt. */
#define isr_SPI_INTC_SET_EN            ((reg32 *) isr_SPI__INTC_SET_EN_REG)

/* Address of the INTC.CLR_EN[x] register to bit clear the isr_SPI interrupt. */
#define isr_SPI_INTC_CLR_EN            ((reg32 *) isr_SPI__INTC_CLR_EN_REG)

/* Address of the INTC.SET_PD[x] register to set the isr_SPI interrupt state to pending. */
#define isr_SPI_INTC_SET_PD            ((reg32 *) isr_SPI__INTC_SET_PD_REG)

/* Address of the INTC.CLR_PD[x] register to clear the isr_SPI interrupt. */
#define isr_SPI_INTC_CLR_PD            ((reg32 *) isr_SPI__INTC_CLR_PD_REG)



#endif /* CY_ISR_isr_SPI_H */


/* [] END OF FILE */
