/* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/

#include "LoRa.h"

uint8_t x = 0;
uint8_t okunan_veri = 0;

void Modul_Reset (void)
{
    LoRa_NSS_Write(1);
    LoRa_RESET_Write(1);
    CyDelay(1);
    LoRa_RESET_Write(0);
    CyDelay(100);
}

void SPIM_SendCommandPacket(uint8 cmd)
{
    uint8 mTxBuffer[] = {};
    
    mTxBuffer[0] = cmd;
    
    SPI_1_SpiUartPutArray(mTxBuffer, 1);
    
    while(1 != SPI_1_SpiUartGetRxBufferSize())
    {
    }
    
    SPI_1_SpiUartClearRxBuffer();
}

void SPI_Tx(uint8_t adress, uint8_t data)
{
    LoRa_RESET_Write(0);
    
    adress = (adress) | (0x80) ;
    
    SPI_1_SpiUartClearRxBuffer();
    SPI_1_SpiUartClearTxBuffer();
    SPI_1_SpiUartWriteTxData(adress);
    while(1 != SPI_1_SpiUartGetRxBufferSize())
    {
    }
    
    SPI_1_SpiUartReadRxData();
    
    SPI_1_SpiUartClearRxBuffer();
    SPI_1_SpiUartClearTxBuffer();
    SPI_1_SpiUartWriteTxData(data);
    while(1 != SPI_1_SpiUartGetRxBufferSize())
    {
    }
    
    SPI_1_SpiUartReadRxData();
    
    LoRa_RESET_Write(1);
}


uint8_t SPI_Rx(uint8_t adress)
{
    LoRa_RESET_Write(0);
    
    SPI_1_SpiUartClearRxBuffer();
    SPI_1_SpiUartClearTxBuffer();    
    SPI_1_SpiUartWriteTxData(adress);
    while(SPI_1_SpiUartGetRxBufferSize() != 1)
    {
    }
    
    SPI_1_SpiUartClearRxBuffer();
    
    SPI_1_SpiUartWriteTxData(0x00);
    while(!SPI_1_SpiUartGetRxBufferSize())
    {
    }
    
    okunan_veri = SPI_1_SpiUartReadRxData();
    
    LoRa_RESET_Write(1);
    
    return okunan_veri;
}


void SX1278_config(void) {
	//SX1278_sleep(module); //Change modem mode Must in Sleep mode
        SPI_Tx(LR_RegOpMode, 0x08); // SLEEP MODE
	CyDelay(15);
        
	SPI_Tx(LR_RegOpMode, 0x88);

        //	903Mhz frekans ayari
        SPI_Tx(LR_RegFrMsb, 0xE1);
        SPI_Tx(LR_RegFrMid, 0xE1);
        SPI_Tx(LR_RegFrLsb, 0x4E);
        
        SPI_Tx(0x39, 0x34);
        
	//setting base parameter
	SPI_Tx(LR_RegPaConfig, SX1278_Power[SX1278_POWER_17DBM]); //Setting output power parameter

	SPI_Tx(LR_RegOcp, 0x0B);			//RegOcp,Close Ocp
	SPI_Tx(LR_RegLna, 0x23);		//RegLNA,High & LNA Enable
        
	//SPI_Tx(LR_RegModemConfig1,((SX1278_LoRaBandwidth[LoRa_BW] << 4) + (SX1278_CR << 1) + 0x00)); //Explicit Enable CRC Enable(0x02) & Error Coding rate 4/5(0x01), 4/6(0x02), 4/7(0x03), 4/8(0x04)

        SPI_Tx(LR_RegModemConfig1,0x78);
        
	//SPI_Tx(LR_RegModemConfig2,((SX1278_SpreadFactor[LoRa_Rate] << 4) + (SX1278_CRC << 2) + 0x03)); //SFactor &  LNA gain set by the internal AGC loop
	SPI_Tx(LR_RegModemConfig2,0x70);

	SPI_Tx(LR_RegSymbTimeoutLsb, 0x08); //RegSymbTimeoutLsb Timeout = 0x3FF(Max)
        SPI_Tx( LR_RegPreambleMsb, 0x00);
        SPI_Tx( LR_RegPreambleLsb, 8);
	SPI_Tx(REG_LR_DIOMAPPING2, 0x01); //RegDioMapping2 DIO5=00, DIO4=01
	//module->readBytes = 0;
        
	//SX1278_standby(module); //Entry standby mode
        SPI_Tx(LR_RegOpMode, 0x09);
}

int LoRaEntryTx(uint8_t length, uint32_t timeout) {
	uint8_t addr;
	uint8_t temp;

	//SX1278_defaultConfig(module); //setting base parameter
        SX1278_config();
	
        SPI_Tx(REG_LR_PADAC, 0x87);	//Tx for 20dBm
	SPI_Tx(LR_RegHopPeriod, 0x00); //RegHopPeriod NO FHSS
	SPI_Tx(REG_LR_DIOMAPPING1, 0x41); //DIO0=01, DIO1=00,DIO2=00, DIO3=01	
        
        //SX1278_clearLoRaIrq(module);
        SPI_Tx(LR_RegIrqFlags, 0xFF);
        
	SPI_Tx(LR_RegIrqFlagsMask, 0xF7); //Open TxDone interrupt
	SPI_Tx(LR_RegPayloadLength, length); //RegPayloadLength 21byte
        
	addr = SPI_Rx(LR_RegFifoTxBaseAddr); //RegFiFoTxBaseAddr
        
	SPI_Tx(LR_RegFifoAddrPtr, addr); //RegFifoAddrPtr

	while (1) {
		temp = SPI_Rx(LR_RegPayloadLength);
		if (temp == length) {
			//module->status = TX;
			return 1;
		}

		if (--timeout == 0) {
			//SX1278_hw_Reset(module->hw);
            Modul_Reset();
                        
			SX1278_config();
			return 0;
		}
	}
}

/* [] END OF FILE */
